Subject: Re: G3 iBook LCD brightness in X under kernel 2.4.25 and 2.6.8

From: Benjamin Herrenschmidt <[email-masked]>
Date: Sat, 27 Nov 2004 12:02:53 +1100

On Fri, 2004-11-26 at 11:28 +0100, Christof Petig wrote:

> > I'm running pbbuttonsd 0.6.6-2 with gtkpbbuttons 0.6.4-3 (which are tools that 
> > enable the LCD to be dimmed and brightened with keyboard pressed). When I'm 
> > running the Debian kernel-image 2.4.25-8 and I press the brightness up or 
> > down keys, I get the on-screen indication from gtkpbbuttons and the LCD dims 
> > or brightens as expected in both X and on the console. However, when I boot 
> > into kernel-image 2.6.8-6 or 2.6.9-1 and press the brightness keys, I get the 
> > on-screen indication in X, but the LCD doesn't change brightness. However, if 
> > I switch to a VT with a console, the brightness changes to what I tried to 
> > change it to. Also, pressing the brightness buttons works fine when I press 
> > them while in the console.

What machine model precisely ? If it's an iBook, only the very first one
had a mach64 based chip and indeed used atyfb-based brightness control,
that might have been broken...

> > My video card is a Mach64, and I'm using the 'ati' driver for X. One guess I 
> > have is that in 2.6, lots more things are built as kernel modules. I'd like 
> > to try build any needed video stuff in, but I don't know what it could be. 
> > Does anyone here have an idea what controls screen brightness in X?

Some earlier models have PMU-controlled brightness, independently on the
video card...

> Your mouse pointer might get some noisy spots on brightness change, ever 
> noticed? I would blame the kernel first (since 2.4 works well).

Ah ? Haven't noticed that ? what machine ? 

> > The reason this is important for me is that the LCD is not dimmed when I close 
> > the lid for sleep, which kind of ruins the point of sleep.
> > 
> > Does anyone have an idea of what else I need to do to get screen dimming to 
> > work under X with Linux 2.6?

You may be missing the atyfb kernel driver.

> Try to ask on the ppc-kernel list (CCed). I suspect that nobody has 
> reimplemented power management for mach64 in 2.6. The fact that lid 
> closing does not put the display to sleep keeps me locked in 2.4, too 
> (though I experienced that 2.6 is way faster).

It is, provided you have the right driver.

> I played with the thought of fixing it myself (like I plan to fix DRI 
> DMA some time) but was unable to allocate ressources (and enough motivation)
> 
> So take this as a "I have the problem, too" posting
>     Christof
> _______________________________________________
> Linuxppc-dev mailing list
> [email-masked]
> https://ozlabs.org/mailman/listinfo/linuxppc-dev
-- 
Benjamin Herrenschmidt <[email-masked]>